# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from enum import Enum
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .honey_token_label import HoneyTokenLabel


class CreateHoneytokenWithContextRequestType(Enum):
    """An enumeration representing different categories.

    :cvar AWS: "AWS"
    :vartype AWS: str
    """

    AWS = "AWS"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(
            map(
                lambda x: x.value,
                CreateHoneytokenWithContextRequestType._member_map_.values(),
            )
        )


@JsonMap({"type_": "type"})
class CreateHoneytokenWithContextRequest(BaseModel):
    """CreateHoneytokenWithContextRequest

    :param name: Honeytoken name.<br>
    :type name: str
    :param description: Honeytoken description.<br>, defaults to None
    :type description: str, optional
    :param type_: Honeytoken type.<br>
    :type type_: CreateHoneytokenWithContextRequestType
    :param labels: Labels to set on the honeytoken. If the label doesn't exist, it will be created., defaults to None
    :type labels: List[HoneyTokenLabel], optional
    :param language: Language to use for the context. If not set but `project_extensions` is set, the languages will be inferred from the extensions., defaults to None
    :type language: str, optional
    :param filename: Filename to use for the context., defaults to None
    :type filename: str, optional
    :param project_extensions: An array of file extensions that can be used for the context., defaults to None
    :type project_extensions: List[str], optional
    """

    def __init__(
        self,
        name: str,
        type_: CreateHoneytokenWithContextRequestType,
        description: str = None,
        labels: List[HoneyTokenLabel] = None,
        language: str = None,
        filename: str = None,
        project_extensions: List[str] = None,
    ):
        self.name = name
        if description is not None:
            self.description = description
        self.type_ = self._enum_matching(
            type_, CreateHoneytokenWithContextRequestType.list(), "type_"
        )
        if labels is not None:
            self.labels = self._define_list(labels, HoneyTokenLabel)
        if language is not None:
            self.language = language
        if filename is not None:
            self.filename = filename
        if project_extensions is not None:
            self.project_extensions = project_extensions
