# This file was generated by liblab | https://liblab.com/

from .utils.validator import Validator
from .utils.base_service import BaseService
from ..net.transport.serializer import Serializer
from ..models.utils.cast_models import cast_models
from ..models.health_check_ok_response import HealthCheckOkResponse


class StatusService(BaseService):

    @cast_models
    def health_check(self) -> HealthCheckOkResponse:
        """Check the status of the API and your token without spending your quota.

        ...
        :raises RequestError: Raised when a request fails, with optional HTTP status code and details.
        ...
        :return: API on and key valid response
        :rtype: HealthCheckOkResponse
        """

        serialized_request = (
            Serializer(f"{self.base_url}/v1/health", self.get_default_headers())
            .serialize()
            .set_method("GET")
        )

        response = self.send_request(serialized_request)

        return HealthCheckOkResponse._unmap(response)
