# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from typing import List
from .utils.json_map import JsonMap
from .base import BaseModel
from .dependency_type_enum import DependencyTypeEnum
from .exposed_vulnerability_output_schema import ExposedVulnerabilityOutputSchema


@JsonMap({})
class PackageVulnerabilityOutputSchema(BaseModel):
    """PackageVulnerabilityOutputSchema

    :param package_full_name: package_full_name
    :type package_full_name: str
    :param version: version
    :type version: str
    :param ecosystem: ecosystem
    :type ecosystem: str
    :param dependency_type: dependency_type, defaults to None
    :type dependency_type: DependencyTypeEnum, optional
    :param vulns: vulns
    :type vulns: List[ExposedVulnerabilityOutputSchema]
    """

    def __init__(
        self,
        package_full_name: str,
        version: str,
        ecosystem: str,
        vulns: List[ExposedVulnerabilityOutputSchema],
        dependency_type: DependencyTypeEnum = None,
    ):
        self.package_full_name = package_full_name
        self.version = version
        self.ecosystem = ecosystem
        if dependency_type is not None:
            self.dependency_type = self._enum_matching(
                dependency_type, DependencyTypeEnum.list(), "dependency_type"
            )
        self.vulns = self._define_list(vulns, ExposedVulnerabilityOutputSchema)
